--[[
	Project....: BGRep
	File.......: minimap.lua
	Description: Minimap icon for BGRep
	Version....: 1.3
	Created....: December 26th 2015 (Azhtyhx)
	Updated....: December 31st 2015 (Azhtyhx)
]]

-----------
-- Setup --
-----------

BGRep = LibStub("AceAddon-3.0"):GetAddon("BGRep")
BGRMinimap = BGRep:NewModule("BGRMinimap", "AceConsole-3.0")
local L = BGRep.L
local db

local mmButton = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("BGRep", {
	type = "launcher",
	icon = "Interface\\AddOns\\BGRep\\Media\\swords",
	tocname = "BGRep",
})

-------------
-- Scripts --
-------------

function mmButton:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE ", 0, -40)
	GameTooltip:SetText("BGRep")
	GameTooltip:AddLine(L["Left-Click: Show/Hide BGRep"], 1, 1, 1)
	GameTooltip:AddLine(L["Right-Click: Show/Hide BGRep Options"], 1, 1, 1)
	GameTooltip:Show()
end

function mmButton:OnClick(button)
	if button == "LeftButton" then
		BGRep:ToggleModule("BGRWindow")
	elseif button == "RightButton" then
		BGRep:Open()
	end
end

-------------------
-- Setup Minimap --
-------------------

function BGRMinimap:OnInitialize()
	BGRep:RegisterModule(BGRMinimap)
end

function BGRMinimap:OnEnable()
	db = BGRep:GetDB()
	-- To avoid having minimap icon show up on /reload even though it is disabled.
	if not secondtime then
		LibStub("LibDBIcon-1.0"):Register("mmButton", mmButton, db.minimapIcon)
		secondtime = true
	end
	
	LibStub("LibDBIcon-1.0"):Show("mmButton", mmButton, db.minimapIcon)
end

function BGRMinimap:OnDisable()
	LibStub("LibDBIcon-1.0"):Hide("mmButton", mmButton, db.minimapIcon)
end